using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;

namespace MoodLight
{
    /// <summary>
    /// To jest główny typ Twojej gry
    /// </summary>
    public class Game1 : Microsoft.Xna.Framework.Game
    {
        GraphicsDeviceManager graphics;
        SpriteBatch spriteBatch;

        // Świat gry - nasze wartości kolorów
        byte redIntensity = 0;
        byte greenIntensity = 0;
        byte blueIntensity = 0;

        Texture2D jakeTexture;
        Rectangle jakeRect;

        public Game1()
        {
            graphics = new GraphicsDeviceManager(this);
            Content.RootDirectory = "Content";
        }

        /// <summary>
        /// Pozwala grze wykonać dowolną inicjalizację jakiej potrzebuje przed rozpoczeciem działania.
        /// To tutaj może ona zażądać potrzebnych usług i załadować związaną zawartość nie graficzną.
        /// Wywołanie base.Initialize wyliczy wszystkie komponenty i także je zainicjuje.
        /// </summary>
        protected override void Initialize()
        {
            jakeRect = new Rectangle(
                0,    // współrzędna X górnego lewego narożnika
                0,    // współrzędna Y górnego lewego narożnika
                GraphicsDevice.Viewport.Width,   // szerokość prostokąta
                GraphicsDevice.Viewport.Height); // wysokość prostokąta

            base.Initialize();
        }

        /// <summary>
        /// LoadContent bedzie wywołany raz na grę i tu należy ładować
        /// całą zawartość.
        /// </summary>
        protected override void LoadContent()
        {
            // Stwórz nowy SpriteBatch, którego można uzyć do rysowania tekstur.
            spriteBatch = new SpriteBatch(GraphicsDevice);

            jakeTexture = this.Content.Load<Texture2D>("jake");
        }

        /// <summary>
        /// UnloadContent bedzie wywołany raz na grę i tu należy usuwać 
        /// całą zawartość.
        /// </summary>
        protected override void UnloadContent()
        {
            // TODO: Usunąć w tym miejscu każdą zawartość nie obsługiwaną przez ContentManager
        }

        /// <summary>
        /// Pozwala uruchomić w grze logikę taką jak aktualizacja świata,
        /// sprawdzenie kolizji, pobranie wejścia i odtwarzanie dźwięku.
        /// </summary>
        /// <param name="gameTime">Dostarcza chwilową wartość zmiennych czasowych.</param>
        protected override void Update(GameTime gameTime)
        {
            // Pozwala opuscić grę
            if (GamePad.GetState(PlayerIndex.One).Buttons.Back == ButtonState.Pressed)
            {
                GamePad.SetVibration(PlayerIndex.One, 0, 0);
                this.Exit();
            }

            GamePadState pad1 = GamePad.GetState(PlayerIndex.One);
            KeyboardState keys = Keyboard.GetState();

            if (keys.IsKeyDown(Keys.Escape)) Exit();

            if (pad1.Buttons.B == ButtonState.Pressed ||
                keys.IsKeyDown(Keys.R)) redIntensity++;

            if (pad1.Buttons.X == ButtonState.Pressed ||
                keys.IsKeyDown(Keys.B)) blueIntensity++;

            if (pad1.Buttons.A == ButtonState.Pressed ||
                keys.IsKeyDown(Keys.G)) greenIntensity++;

            if (pad1.Buttons.Y == ButtonState.Pressed ||
                keys.IsKeyDown(Keys.Y))
            {
                redIntensity++;
                greenIntensity++;
            }

            if (redIntensity > 220 ||
                 greenIntensity > 220 ||
                 blueIntensity > 220)
            {
                GamePad.SetVibration(PlayerIndex.One, 0, 1);
            }
            else
            {
                GamePad.SetVibration(PlayerIndex.One, 0, 0);
            }

            base.Update(gameTime);
        }

        /// <summary>
        /// Metoda wywoływana kiedy gra powinna się wyswietlić.
        /// </summary>
        /// <param name="gameTime">Dostarcza chwilową wartość zmiennych czasowych.</param>
        protected override void Draw(GameTime gameTime)
        {
            Color backgroundColor;
            backgroundColor =
               new Color(redIntensity, greenIntensity, blueIntensity);

            spriteBatch.Begin();
            spriteBatch.Draw(jakeTexture, jakeRect, backgroundColor);
            spriteBatch.End();

            base.Draw(gameTime);
        }
    }
}
